<?php

class upload{
	
	//connection strings
	private $db_host 	 = 'localhost';
	private $db_username = 'root';
	private $db_password = '';
	private $db_name	 = 'image_db';
	private $con;
	//image folder path
	private $img_path 	 = 'uploads/';
	
	public function __construct()
	{
		//this connects to the database immediately after the instance created
		$this->con = mysqli_connect($this->db_host,$this->db_username,$this->db_password,$this->db_name);
		if(mysqli_connect_errno()){
			echo "Connection Failed, Please check your DB connection"; 
		}
	}
	
	public function upload_image_and_store($post, $files)
	{
		//get extension from the file
		$allowedExts = array("gif", "jpeg", "jpg", "png");
		$temp = explode(".", $files["img_file"]["name"]);
		$extension = end($temp);

		if ((($files["img_file"]["type"] == "image/gif") //check image is gif
		|| ($files["img_file"]["type"] == "image/jpeg") //check image is jpeg
		|| ($files["img_file"]["type"] == "image/jpg") 	//check image is jpg
		|| ($files["img_file"]["type"] == "image/png")) //check image is png
		&& ($files["img_file"]["size"] < 2000000) //check if image size is below 2MB
		&& in_array(trim($extension), $allowedExts)) //check the extensions also
		{
			if ($files["img_file"]["error"] > 0) //check if any file error
			{
				echo $files["img_file"]["error"];
			}
			else 
			{
				//unique file name to avoid overwriting
				$filename = time().$files["img_file"]["name"];
				
				//move the uploaded file to folder
				$upload =  move_uploaded_file($files["img_file"]["tmp_name"], $this->img_path . $filename);
				
				//after upload the file store the image path and other details in database
				if($upload){
					$this->store_image_in_db($filename, $post);
				}
			}
		}
		else 
		{
			echo "Please upload only image files and should be less than 2MB";
		}
	}
	
	private function store_image_in_db($filename, $post)
	{
		//sanitize the input
		$img_name = mysqli_real_escape_string($this->con, $post['img_name']);
		$img_cat  = mysqli_real_escape_string($this->con, $post['img_cat']);
		
		//insert a record into the table image_uploads
		$sql_string 	= "insert into image_uploads (img_name, img_cat, img_uploaded_name, upload_dt) values ('$img_name', '$img_cat', '$filename', now())";
		$query  		= mysqli_query($this->con, $sql_string);
		if($query){
			
			echo "Image uploaded and added into the database!";
		}else{
			echo "Check your DB or Table";
		}
	}
	
	public function get_images()
	{
		$arr = array();
		//get all images from table image_uploads
		$sql_string = "select * from image_uploads";
		$query 		= mysqli_query($this->con, $sql_string);
		
		while($row = mysqli_fetch_assoc($query)){
			$arr[] = $row;
		}
		//return the result set
		return $arr;
	}
}

?>